// <auto-generated />

using System;
using System.Reflection;
using System.Resources;
using JetBrains.Annotations;
using Microsoft.EntityFrameworkCore.Diagnostics;
using Microsoft.Extensions.Logging;

namespace Microsoft.EntityFrameworkCore.SqlServer.Internal
{
    /// <summary>
    ///		This API supports the Entity Framework Core infrastructure and is not intended to be used
    ///     directly from your code. This API may change or be removed in future releases.
    /// </summary>
    public static class SqlServerStrings
    {
        private static readonly ResourceManager _resourceManager
            = new ResourceManager("Microsoft.EntityFrameworkCore.SqlServer.Properties.SqlServerStrings", typeof(SqlServerStrings).GetTypeInfo().Assembly);

        /// <summary>
        ///     Identity value generation cannot be used for the property '{property}' on entity type '{entityType}' because the property type is '{propertyType}'. Identity value generation can only be used with signed integer properties.
        /// </summary>
        public static string IdentityBadType([CanBeNull] object property, [CanBeNull] object entityType, [CanBeNull] object propertyType)
            => string.Format(
                GetString("IdentityBadType", nameof(property), nameof(entityType), nameof(propertyType)),
                property, entityType, propertyType);

        /// <summary>
        ///     Data type '{dataType}' is not supported in this form. Either specify the length explicitly in the type name, for example as '{dataType}(16)', or remove the data type and use APIs such as HasMaxLength to allow EF choose the data type.
        /// </summary>
        public static string UnqualifiedDataType([CanBeNull] object dataType)
            => string.Format(
                GetString("UnqualifiedDataType", nameof(dataType)),
                dataType);

        /// <summary>
        ///     Data type '{dataType}' for property '{property}' is not supported in this form. Either specify the length explicitly in the type name, for example as '{dataType}(16)', or remove the data type and use APIs such as HasMaxLength to allow EF choose the data type.
        /// </summary>
        public static string UnqualifiedDataTypeOnProperty([CanBeNull] object dataType, [CanBeNull] object property)
            => string.Format(
                GetString("UnqualifiedDataTypeOnProperty", nameof(dataType), nameof(property)),
                dataType, property);

        /// <summary>
        ///     SQL Server sequences cannot be used to generate values for the property '{property}' on entity type '{entityType}' because the property type is '{propertyType}'. Sequences can only be used with integer properties.
        /// </summary>
        public static string SequenceBadType([CanBeNull] object property, [CanBeNull] object entityType, [CanBeNull] object propertyType)
            => string.Format(
                GetString("SequenceBadType", nameof(property), nameof(entityType), nameof(propertyType)),
                property, entityType, propertyType);

        /// <summary>
        ///     SQL Server requires the table name to be specified for rename index operations. Specify table name in the call to MigrationBuilder.RenameIndex.
        /// </summary>
        public static string IndexTableRequired
            => GetString("IndexTableRequired");

        /// <summary>
        ///     To set memory-optimized on a table on or off the table needs to be dropped and recreated.
        /// </summary>
        public static string AlterMemoryOptimizedTable
            => GetString("AlterMemoryOptimizedTable");

        /// <summary>
        ///     To change the IDENTITY property of a column, the column needs to be dropped and recreated.
        /// </summary>
        public static string AlterIdentityColumn
            => GetString("AlterIdentityColumn");

        /// <summary>
        ///     An exception has been raised that is likely due to a transient failure. Consider enabling transient error resiliency by adding 'EnableRetryOnFailure()' to the 'UseSqlServer' call.
        /// </summary>
        public static string TransientExceptionDetected
            => GetString("TransientExceptionDetected");

        /// <summary>
        ///     No type was specified for the decimal column '{property}' on entity type '{entityType}'. This will cause values to be silently truncated if they do not fit in the default precision and scale. Explicitly specify the SQL server column type that can accommodate all the values using 'HasColumnType()'.
        /// </summary>
        public static readonly EventDefinition<string, string> LogDefaultDecimalTypeColumn
            = new EventDefinition<string, string>(
                SqlServerEventId.DecimalTypeDefaultWarning,
                LogLevel.Warning,
                "SqlServerEventId.DecimalTypeDefaultWarning",
                LoggerMessage.Define<string, string>(
                    LogLevel.Warning,
                    SqlServerEventId.DecimalTypeDefaultWarning,
                    _resourceManager.GetString("LogDefaultDecimalTypeColumn")));

        /// <summary>
        ///     The property '{property}' on entity type '{entityType}' is of type 'byte', but is set up to use a SQL Server identity column. This requires that values starting at 255 and counting down will be used for temporary key values. A temporary key value is needed for every entity inserted in a single call to 'SaveChanges'. Care must be taken that these values do not collide with real key values.
        /// </summary>
        public static readonly EventDefinition<string, string> LogByteIdentityColumn
            = new EventDefinition<string, string>(
                SqlServerEventId.ByteIdentityColumnWarning,
                LogLevel.Warning,
                "SqlServerEventId.ByteIdentityColumnWarning",
                LoggerMessage.Define<string, string>(
                    LogLevel.Warning,
                    SqlServerEventId.ByteIdentityColumnWarning,
                    _resourceManager.GetString("LogByteIdentityColumn")));

        /// <summary>
        ///     The property '{property}' on entity type '{entityType}' is configured to use 'SequenceHiLo' value generator, which is only intended for keys. If this was intentional configure an alternate key on the property, otherwise call 'ValueGeneratedNever' or configure store generation for this property.
        /// </summary>
        public static string NonKeyValueGeneration([CanBeNull] object property, [CanBeNull] object entityType)
            => string.Format(
                GetString("NonKeyValueGeneration", nameof(property), nameof(entityType)),
                property, entityType);

        /// <summary>
        ///     The properties {properties} are configured to use 'Identity' value generator and are mapped to the same table '{table}'. Only one column per table can be configured as 'Identity'. Call 'ValueGeneratedNever' for properties that should not use 'Identity'.
        /// </summary>
        public static string MultipleIdentityColumns([CanBeNull] object properties, [CanBeNull] object table)
            => string.Format(
                GetString("MultipleIdentityColumns", nameof(properties), nameof(table)),
                properties, table);

        /// <summary>
        ///     Cannot use table '{table}' for entity type '{entityType}' since it is being used for entity type '{otherEntityType}' and entity type '{memoryOptimizedEntityType}' is marked as memory-optimized, but entity type '{nonMemoryOptimizedEntityType}' is not.
        /// </summary>
        public static string IncompatibleTableMemoryOptimizedMismatch([CanBeNull] object table, [CanBeNull] object entityType, [CanBeNull] object otherEntityType, [CanBeNull] object memoryOptimizedEntityType, [CanBeNull] object nonMemoryOptimizedEntityType)
            => string.Format(
                GetString("IncompatibleTableMemoryOptimizedMismatch", nameof(table), nameof(entityType), nameof(otherEntityType), nameof(memoryOptimizedEntityType), nameof(nonMemoryOptimizedEntityType)),
                table, entityType, otherEntityType, memoryOptimizedEntityType, nonMemoryOptimizedEntityType);

        /// <summary>
        ///     Found default schema {defaultSchema}.
        /// </summary>
        public static readonly EventDefinition<string> LogFoundDefaultSchema
            = new EventDefinition<string>(
                SqlServerEventId.DefaultSchemaFound,
                LogLevel.Debug,
                "SqlServerEventId.DefaultSchemaFound",
                LoggerMessage.Define<string>(
                    LogLevel.Debug,
                    SqlServerEventId.DefaultSchemaFound,
                    _resourceManager.GetString("LogFoundDefaultSchema")));

        /// <summary>
        ///     Found type alias with name: {alias} which maps to underlying data type {dataType}.
        /// </summary>
        public static readonly EventDefinition<string, string> LogFoundTypeAlias
            = new EventDefinition<string, string>(
                SqlServerEventId.TypeAliasFound,
                LogLevel.Debug,
                "SqlServerEventId.TypeAliasFound",
                LoggerMessage.Define<string, string>(
                    LogLevel.Debug,
                    SqlServerEventId.TypeAliasFound,
                    _resourceManager.GetString("LogFoundTypeAlias")));

        /// <summary>
        ///     Found column with table: {tableName}, column name: {columnName}, ordinal: {ordinal}, data type: {dataType}, maximum length: {maxLength}, precision: {precision}, scale: {scale}, nullable: {isNullable}, identity: {isIdentity}, default value: {defaultValue}, computed value: {computedValue}
        /// </summary>
        public static readonly FallbackEventDefinition LogFoundColumn
            = new FallbackEventDefinition(
                SqlServerEventId.ColumnFound,
                LogLevel.Debug,
                "SqlServerEventId.ColumnFound",
                _resourceManager.GetString("LogFoundColumn"));

        /// <summary>
        ///     Found foreign key on table: {tableName}, name: {foreignKeyName}, principal table: {principalTableName}, delete action: {deleteAction}.
        /// </summary>
        public static readonly EventDefinition<string, string, string, string> LogFoundForeignKey
            = new EventDefinition<string, string, string, string>(
                SqlServerEventId.ForeignKeyFound,
                LogLevel.Debug,
                "SqlServerEventId.ForeignKeyFound",
                LoggerMessage.Define<string, string, string, string>(
                    LogLevel.Debug,
                    SqlServerEventId.ForeignKeyFound,
                    _resourceManager.GetString("LogFoundForeignKey")));

        /// <summary>
        ///     For foreign key {fkName} on table {tableName}, unable to model the end of the foreign key on principal table {principaltableName}. This is usually because the principal table was not included in the selection set.
        /// </summary>
        public static readonly EventDefinition<string, string, string> LogPrincipalTableNotInSelectionSet
            = new EventDefinition<string, string, string>(
                SqlServerEventId.ForeignKeyReferencesMissingPrincipalTableWarning,
                LogLevel.Warning,
                "SqlServerEventId.ForeignKeyReferencesMissingPrincipalTableWarning",
                LoggerMessage.Define<string, string, string>(
                    LogLevel.Warning,
                    SqlServerEventId.ForeignKeyReferencesMissingPrincipalTableWarning,
                    _resourceManager.GetString("LogPrincipalTableNotInSelectionSet")));

        /// <summary>
        ///     Unable to find a schema in the database matching the selected schema {schema}.
        /// </summary>
        public static readonly EventDefinition<string> LogMissingSchema
            = new EventDefinition<string>(
                SqlServerEventId.MissingSchemaWarning,
                LogLevel.Warning,
                "SqlServerEventId.MissingSchemaWarning",
                LoggerMessage.Define<string>(
                    LogLevel.Warning,
                    SqlServerEventId.MissingSchemaWarning,
                    _resourceManager.GetString("LogMissingSchema")));

        /// <summary>
        ///     Unable to find a table in the database matching the selected table {table}.
        /// </summary>
        public static readonly EventDefinition<string> LogMissingTable
            = new EventDefinition<string>(
                SqlServerEventId.MissingTableWarning,
                LogLevel.Warning,
                "SqlServerEventId.MissingTableWarning",
                LoggerMessage.Define<string>(
                    LogLevel.Warning,
                    SqlServerEventId.MissingTableWarning,
                    _resourceManager.GetString("LogMissingTable")));

        /// <summary>
        ///     Found sequence name: {name}, data type: {dataType}, cyclic: {isCyclic}, increment: {increment}, start: {start}, minimum: {min}, maximum: {max}.
        /// </summary>
        public static readonly FallbackEventDefinition LogFoundSequence
            = new FallbackEventDefinition(
                SqlServerEventId.SequenceFound,
                LogLevel.Debug,
                "SqlServerEventId.SequenceFound",
                _resourceManager.GetString("LogFoundSequence"));

        /// <summary>
        ///     Found table with name: {name}.
        /// </summary>
        public static readonly EventDefinition<string> LogFoundTable
            = new EventDefinition<string>(
                SqlServerEventId.TableFound,
                LogLevel.Debug,
                "SqlServerEventId.TableFound",
                LoggerMessage.Define<string>(
                    LogLevel.Debug,
                    SqlServerEventId.TableFound,
                    _resourceManager.GetString("LogFoundTable")));

        /// <summary>
        ///     The database name could not be determined. To use EnsureDeleted, the connection string must specify Initial Catalog.
        /// </summary>
        public static string NoInitialCatalog
            => GetString("NoInitialCatalog");

        /// <summary>
        ///     '{entityType1}.{property1}' and '{entityType2}.{property2}' are both mapped to column '{columnName}' in '{table}' but are configured with different value generation strategies.
        /// </summary>
        public static string DuplicateColumnNameValueGenerationStrategyMismatch([CanBeNull] object entityType1, [CanBeNull] object property1, [CanBeNull] object entityType2, [CanBeNull] object property2, [CanBeNull] object columnName, [CanBeNull] object table)
            => string.Format(
                GetString("DuplicateColumnNameValueGenerationStrategyMismatch", nameof(entityType1), nameof(property1), nameof(entityType2), nameof(property2), nameof(columnName), nameof(table)),
                entityType1, property1, entityType2, property2, columnName, table);

        /// <summary>
        ///     Found index with name: {indexName}, table: {tableName}, is unique: {isUnique}.
        /// </summary>
        public static readonly EventDefinition<string, string, bool> LogFoundIndex
            = new EventDefinition<string, string, bool>(
                SqlServerEventId.IndexFound,
                LogLevel.Debug,
                "SqlServerEventId.IndexFound",
                LoggerMessage.Define<string, string, bool>(
                    LogLevel.Debug,
                    SqlServerEventId.IndexFound,
                    _resourceManager.GetString("LogFoundIndex")));

        /// <summary>
        ///     Found primary key with name: {primaryKeyName}, table: {tableName}.
        /// </summary>
        public static readonly EventDefinition<string, string> LogFoundPrimaryKey
            = new EventDefinition<string, string>(
                SqlServerEventId.PrimaryKeyFound,
                LogLevel.Debug,
                "SqlServerEventId.PrimaryKeyFound",
                LoggerMessage.Define<string, string>(
                    LogLevel.Debug,
                    SqlServerEventId.PrimaryKeyFound,
                    _resourceManager.GetString("LogFoundPrimaryKey")));

        /// <summary>
        ///     Found unique constraint with name: {uniqueConstraintName}, table: {tableName}.
        /// </summary>
        public static readonly EventDefinition<string, string> LogFoundUniqueConstraint
            = new EventDefinition<string, string>(
                SqlServerEventId.UniqueConstraintFound,
                LogLevel.Debug,
                "SqlServerEventId.UniqueConstraintFound",
                LoggerMessage.Define<string, string>(
                    LogLevel.Debug,
                    SqlServerEventId.UniqueConstraintFound,
                    _resourceManager.GetString("LogFoundUniqueConstraint")));

        /// <summary>
        ///     For foreign key {foreignKeyName} on table {tableName}, unable to find the column called {principalColumnName} on the foreign key's principal table, {principaltableName}. Skipping foreign key.
        /// </summary>
        public static readonly EventDefinition<string, string, string, string> LogPrincipalColumnNotFound
            = new EventDefinition<string, string, string, string>(
                SqlServerEventId.ForeignKeyPrincipalColumnMissingWarning,
                LogLevel.Warning,
                "SqlServerEventId.ForeignKeyPrincipalColumnMissingWarning",
                LoggerMessage.Define<string, string, string, string>(
                    LogLevel.Warning,
                    SqlServerEventId.ForeignKeyPrincipalColumnMissingWarning,
                    _resourceManager.GetString("LogPrincipalColumnNotFound")));

        /// <summary>
        ///     The specified table '{table}' is not valid. Specify tables using the format '[schema].[table]'.
        /// </summary>
        public static string InvalidTableToIncludeInScaffolding([CanBeNull] object table)
            => string.Format(
                GetString("InvalidTableToIncludeInScaffolding", nameof(table)),
                table);

        /// <summary>
        ///     The 'FreeText' method is not supported because the query has switched to client-evaluation. Inspect the log to determine which query expressions are triggering client-evaluation.
        /// </summary>
        public static string FreeTextFunctionOnClient
            => GetString("FreeTextFunctionOnClient");

        /// <summary>
        ///     The expression passed to the 'propertyReference' parameter of the 'FreeText' method is not a valid reference to a property. The expression should represent a reference to a full-text indexed property on the object referenced in the from clause: 'from e in context.Entities where EF.Functions.FreeText(e.SomeProperty, textToSearchFor) select e'
        /// </summary>
        public static string InvalidColumnNameForFreeText
            => GetString("InvalidColumnNameForFreeText");

        /// <summary>
        ///     Include property '{entityType}.{property}' cannot be defined multiple times
        /// </summary>
        public static string IncludePropertyDuplicated([CanBeNull] object entityType, [CanBeNull] object property)
            => string.Format(
                GetString("IncludePropertyDuplicated", nameof(entityType), nameof(property)),
                entityType, property);

        /// <summary>
        ///     Include property '{entityType}.{property}' is already included in the index
        /// </summary>
        public static string IncludePropertyInIndex([CanBeNull] object entityType, [CanBeNull] object property)
            => string.Format(
                GetString("IncludePropertyInIndex", nameof(entityType), nameof(property)),
                entityType, property);

        /// <summary>
        ///     Include property '{entityType}.{property}' not found
        /// </summary>
        public static string IncludePropertyNotFound([CanBeNull] object entityType, [CanBeNull] object property)
            => string.Format(
                GetString("IncludePropertyNotFound", nameof(entityType), nameof(property)),
                entityType, property);

        /// <summary>
        ///     The 'Contains' method is not supported because the query has switched to client-evaluation. Inspect the log to determine which query expressions are triggering client-evaluation.
        /// </summary>
        public static string ContainsFunctionOnClient
            => GetString("ContainsFunctionOnClient");

        /// <summary>
        ///     Skipping foreign key '{foreignKeyName}' on table '{tableName}' since all of its columns reference themselves.
        /// </summary>
        public static readonly EventDefinition<string, string> LogReflexiveConstraintIgnored
            = new EventDefinition<string, string>(
                SqlServerEventId.ReflexiveConstraintIgnored,
                LogLevel.Debug,
                "SqlServerEventId.ReflexiveConstraintIgnored",
                LoggerMessage.Define<string, string>(
                    LogLevel.Debug,
                    SqlServerEventId.ReflexiveConstraintIgnored,
                    _resourceManager.GetString("LogReflexiveConstraintIgnored")));

        /// <summary>
        ///     The keys {key1} on '{entityType1}' and {key2} on '{entityType2}' are both mapped to '{table}.{keyName}' but with different clustering.
        /// </summary>
        public static string DuplicateKeyMismatchedClustering([CanBeNull] object key1, [CanBeNull] object entityType1, [CanBeNull] object key2, [CanBeNull] object entityType2, [CanBeNull] object table, [CanBeNull] object keyName)
            => string.Format(
                GetString("DuplicateKeyMismatchedClustering", nameof(key1), nameof(entityType1), nameof(key2), nameof(entityType2), nameof(table), nameof(keyName)),
                key1, entityType1, key2, entityType2, table, keyName);

        private static string GetString(string name, params string[] formatterNames)
        {
            var value = _resourceManager.GetString(name);
            for (var i = 0; i < formatterNames.Length; i++)
            {
                value = value.Replace("{" + formatterNames[i] + "}", "{" + i + "}");
            }

            return value;
        }
    }
}
