// <auto-generated />

using System;
using System.Reflection;
using System.Resources;
using JetBrains.Annotations;
using Microsoft.EntityFrameworkCore.Diagnostics;
using Microsoft.Extensions.Logging;

namespace Microsoft.EntityFrameworkCore.Sqlite.Internal
{
    /// <summary>
    ///		This API supports the Entity Framework Core infrastructure and is not intended to be used
    ///     directly from your code. This API may change or be removed in future releases.
    /// </summary>
    public static class SqliteStrings
    {
        private static readonly ResourceManager _resourceManager
            = new ResourceManager("Microsoft.EntityFrameworkCore.Sqlite.Properties.SqliteStrings", typeof(SqliteStrings).GetTypeInfo().Assembly);

        /// <summary>
        ///     SQLite does not support this migration operation ('{operation}'). For more information, see http://go.microsoft.com/fwlink/?LinkId=723262.
        /// </summary>
        public static string InvalidMigrationOperation([CanBeNull] object operation)
            => string.Format(
                GetString("InvalidMigrationOperation", nameof(operation)),
                operation);

        /// <summary>
        ///     Generating idempotent scripts for migration is not currently supported by SQLite. For more information, see http://go.microsoft.com/fwlink/?LinkId=723262.
        /// </summary>
        public static string MigrationScriptGenerationNotSupported
            => GetString("MigrationScriptGenerationNotSupported");

        /// <summary>
        ///     The entity type '{entityType}' is configured to use schema '{schema}'. SQLite does not support schemas. This configuration will be ignored by the SQLite provider.
        /// </summary>
        public static readonly EventDefinition<string, string> LogSchemaConfigured
            = new EventDefinition<string, string>(
                SqliteEventId.SchemaConfiguredWarning,
                LogLevel.Warning,
                "SqliteEventId.SchemaConfiguredWarning",
                LoggerMessage.Define<string, string>(
                    LogLevel.Warning,
                    SqliteEventId.SchemaConfiguredWarning,
                    _resourceManager.GetString("LogSchemaConfigured")));

        /// <summary>
        ///     The model was configured with the database sequence '{sequence}'. SQLite does not support sequences.
        /// </summary>
        public static readonly EventDefinition<string> LogSequenceConfigured
            = new EventDefinition<string>(
                SqliteEventId.SequenceConfiguredWarning,
                LogLevel.Warning,
                "SqliteEventId.SequenceConfiguredWarning",
                LoggerMessage.Define<string>(
                    LogLevel.Warning,
                    SqliteEventId.SequenceConfiguredWarning,
                    _resourceManager.GetString("LogSequenceConfigured")));

        /// <summary>
        ///     SQLite does not support sequences. For more information, see http://go.microsoft.com/fwlink/?LinkId=723262.
        /// </summary>
        public static string SequencesNotSupported
            => GetString("SequencesNotSupported");

        /// <summary>
        ///     SQLite doesn't support schemas. The specified schema selection arguments will be ignored.
        /// </summary>
        public static readonly EventDefinition LogUsingSchemaSelectionsWarning
            = new EventDefinition(
                SqliteEventId.SchemasNotSupportedWarning,
                LogLevel.Warning,
                "SqliteEventId.SchemasNotSupportedWarning",
                LoggerMessage.Define(
                    LogLevel.Warning,
                    SqliteEventId.SchemasNotSupportedWarning,
                    _resourceManager.GetString("LogUsingSchemaSelectionsWarning")));

        /// <summary>
        ///     Found column on table: {tableName}, column name: {columnName}, data type: {dataType}, not nullable: {isNotNullable}, default value: {defaultValue}.
        /// </summary>
        public static readonly EventDefinition<string, string, string, bool, string> LogFoundColumn
            = new EventDefinition<string, string, string, bool, string>(
                SqliteEventId.ColumnFound,
                LogLevel.Debug,
                "SqliteEventId.ColumnFound",
                LoggerMessage.Define<string, string, string, bool, string>(
                    LogLevel.Debug,
                    SqliteEventId.ColumnFound,
                    _resourceManager.GetString("LogFoundColumn")));

        /// <summary>
        ///     Found foreign key on table: {tableName}, id: {id}, principal table: {principalTableName}, delete action: {deleteAction}.
        /// </summary>
        public static readonly EventDefinition<string, long, string, string> LogFoundForeignKey
            = new EventDefinition<string, long, string, string>(
                SqliteEventId.ForeignKeyFound,
                LogLevel.Debug,
                "SqliteEventId.ForeignKeyFound",
                LoggerMessage.Define<string, long, string, string>(
                    LogLevel.Debug,
                    SqliteEventId.ForeignKeyFound,
                    _resourceManager.GetString("LogFoundForeignKey")));

        /// <summary>
        ///     Could not scaffold the foreign key '{foreignKeyName}'. The referenced table could not be found. This most likely occurred because the referenced table was excluded from scaffolding.
        /// </summary>
        public static readonly EventDefinition<string> LogForeignKeyScaffoldErrorPrincipalTableNotFound
            = new EventDefinition<string>(
                SqliteEventId.ForeignKeyReferencesMissingTableWarning,
                LogLevel.Warning,
                "SqliteEventId.ForeignKeyReferencesMissingTableWarning",
                LoggerMessage.Define<string>(
                    LogLevel.Warning,
                    SqliteEventId.ForeignKeyReferencesMissingTableWarning,
                    _resourceManager.GetString("LogForeignKeyScaffoldErrorPrincipalTableNotFound")));

        /// <summary>
        ///     Found table with name: {name}.
        /// </summary>
        public static readonly EventDefinition<string> LogFoundTable
            = new EventDefinition<string>(
                SqliteEventId.TableFound,
                LogLevel.Debug,
                "SqliteEventId.TableFound",
                LoggerMessage.Define<string>(
                    LogLevel.Debug,
                    SqliteEventId.TableFound,
                    _resourceManager.GetString("LogFoundTable")));

        /// <summary>
        ///     Unable to find a table in the database matching the selected table {table}.
        /// </summary>
        public static readonly EventDefinition<string> LogMissingTable
            = new EventDefinition<string>(
                SqliteEventId.MissingTableWarning,
                LogLevel.Warning,
                "SqliteEventId.MissingTableWarning",
                LoggerMessage.Define<string>(
                    LogLevel.Warning,
                    SqliteEventId.MissingTableWarning,
                    _resourceManager.GetString("LogMissingTable")));

        /// <summary>
        ///     For foreign key with identity {id} on table {tableName}, unable to find the column called {principalColumnName} on the foreign key's principal table, {principaltableName}. Skipping foreign key.
        /// </summary>
        public static readonly EventDefinition<string, string, string, string> LogPrincipalColumnNotFound
            = new EventDefinition<string, string, string, string>(
                SqliteEventId.ForeignKeyPrincipalColumnMissingWarning,
                LogLevel.Warning,
                "SqliteEventId.ForeignKeyPrincipalColumnMissingWarning",
                LoggerMessage.Define<string, string, string, string>(
                    LogLevel.Warning,
                    SqliteEventId.ForeignKeyPrincipalColumnMissingWarning,
                    _resourceManager.GetString("LogPrincipalColumnNotFound")));

        /// <summary>
        ///     Found index with name: {indexName}, table: {tableName}, is unique: {isUnique}.
        /// </summary>
        public static readonly EventDefinition<string, string, bool?> LogFoundIndex
            = new EventDefinition<string, string, bool?>(
                SqliteEventId.IndexFound,
                LogLevel.Debug,
                "SqliteEventId.IndexFound",
                LoggerMessage.Define<string, string, bool?>(
                    LogLevel.Debug,
                    SqliteEventId.IndexFound,
                    _resourceManager.GetString("LogFoundIndex")));

        /// <summary>
        ///     Found primary key with name: {primaryKeyName}, table: {tableName}.
        /// </summary>
        public static readonly EventDefinition<string, string> LogFoundPrimaryKey
            = new EventDefinition<string, string>(
                SqliteEventId.PrimaryKeyFound,
                LogLevel.Debug,
                "SqliteEventId.PrimaryKeyFound",
                LoggerMessage.Define<string, string>(
                    LogLevel.Debug,
                    SqliteEventId.PrimaryKeyFound,
                    _resourceManager.GetString("LogFoundPrimaryKey")));

        /// <summary>
        ///     Found unique constraint with name: {uniqueConstraintName}, table: {tableName}.
        /// </summary>
        public static readonly EventDefinition<string, string> LogFoundUniqueConstraint
            = new EventDefinition<string, string>(
                SqliteEventId.UniqueConstraintFound,
                LogLevel.Debug,
                "SqliteEventId.UniqueConstraintFound",
                LoggerMessage.Define<string, string>(
                    LogLevel.Debug,
                    SqliteEventId.UniqueConstraintFound,
                    _resourceManager.GetString("LogFoundUniqueConstraint")));

        private static string GetString(string name, params string[] formatterNames)
        {
            var value = _resourceManager.GetString(name);
            for (var i = 0; i < formatterNames.Length; i++)
            {
                value = value.Replace("{" + formatterNames[i] + "}", "{" + i + "}");
            }

            return value;
        }
    }
}
