﻿// Copyright (c) .NET Foundation. All rights reserved.
// Licensed under the Apache License, Version 2.0. See License.txt in the project root for license information.

namespace Microsoft.EntityFrameworkCore.Metadata.Builders
{
    /// <summary>
    ///     <para>
    ///         Instances of this class are returned from methods when using the <see cref="ModelBuilder" /> API
    ///         and it is not designed to be directly constructed in your application code.
    ///     </para>
    /// </summary>
    /// <typeparam name="T"> The entity type being configured. </typeparam>
    // ReSharper disable once UnusedTypeParameter
    public class OwnedEntityTypeBuilder<T> : OwnedEntityTypeBuilder
    {
    }
}
